/*
GPC demo code. C wrapper code for filelockdemo.pas.

Copyright (C) 1999 Free Software Foundation, Inc.

Author: Frank Heckenbach <frank@pascal.gnu.de>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 2.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.
*/

#include <unistd.h>
#include <stdio.h>
#include <signal.h>
#include <sys/file.h>

typedef unsigned char Boolean;

int filelock (FILE*, Boolean, Boolean);
int filelock (FILE* f, Boolean Exclusive, Boolean DontBlock)
{
  return flock (fileno (f), (Exclusive ? LOCK_EX : LOCK_SH) | (DontBlock ? LOCK_NB : 0));
}

int fileunlock (FILE*);
int fileunlock (FILE* f)
{
  return flock (fileno (f), LOCK_UN);
}

int settimeraction (int Seconds, void (*Proc)(int));
int settimeraction (int Seconds, void (*Proc)(int))
{
  alarm (Seconds);
  return signal (SIGALRM, Proc) == SIG_ERR ? -1 : 0;
}
