{
BP compatible strings unit

Copyright (C) 1999 Free Software Foundation, Inc.

Author: Frank Heckenbach <frank@pascal.gnu.de>

This file is part of GNU Pascal Library. The GNU Pascal Library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any
later version.

The GNU Pascal Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU Pascal Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.
}

unit Strings;

interface

uses GPC;

function  StrLen     (Src : CString) : SizeType;                            asmname '_p_strlen';
function  StrEnd     (Src : CString) : CString;                             asmname '_p_strend';
function  StrMove    (Dest, Source : CString; Count : SizeType) : CString;  asmname '_p_strmove';
function  StrCopy    (Dest, Source : CString) : CString;                    asmname '_p_strcpy';
function  StrECopy   (Dest, Source : CString) : CString;                    asmname '_p_strecpy';
function  StrLCopy   (Dest, Source : CString; MaxLen : SizeType) : CString; asmname '_p_strlcpy';
function  StrPCopy   (Dest : CString; const Source : String) : CString;     asmname '_p_cstringcopystring';
function  StrCat     (Dest, Source : CString) : CString;                    asmname '_p_strcat';
function  StrLCat    (Dest, Source : CString; MaxLen : SizeType) : CString; asmname '_p_strlcat';
function  StrComp    (s1, s2 : CString) : Integer;                          asmname '_p_strcmp';
function  StrIComp   (s1, s2 : CString) : Integer;                          asmname '_p_strcasecmp';
function  StrLComp   (s1, s2 : CString; MaxLen : SizeType) : Integer;       asmname '_p_strlcmp';
function  StrLIComp  (s1, s2 : CString; MaxLen : SizeType) : Integer;       asmname '_p_strlcasecmp';
function  StrScan    (Src : CString; Ch : Char) : CString;                  asmname '_p_strscan';
function  StrRScan   (Src : CString; Ch : Char) : CString;                  asmname '_p_strrscan';
function  StrPos     (Str, SubStr : CString) : CString;                     asmname '_p_strpos';
function  StrRPos    (Str, SubStr : CString) : CString;                     asmname '_p_strrpos';
function  StrUpper   (s : CString) : CString;                               asmname '_p_strupper';
function  StrLower   (s : CString) : CString;                               asmname '_p_strlower';
function  StrPas     (Str : CString) : TString;                             asmname '_p_strpas';
function  StrEmpty   (s : CString) : Boolean;                               asmname '_p_strempty';
function  StrNew     (Src : CString) : CString;                             asmname '_p_strdup';
procedure StrDispose (s : CString);                                         asmname '_p_dispose';

implementation

function StrPas (Str : CString) : TString;
begin
  StrPas := CString2String (Str)
end;

end.
