{
Turbo Pascal 3.0 compatibility unit

Copyright (C) 1998-99 Free Software Foundation, Inc.

Author: Frank Heckenbach <frank@pascal.gnu.de>

This library is free software; you can redistribute it and/or modify
it under the terms of the GNU Library General Public License as published by
the Free Software Foundation, version 2.

This library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
License for more details.

You should have received a copy of the GNU Library General Public License
along with this library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.
}

{$if __GPC_RELEASE__ < 19981206}
{$error This unit requires GPC release 19981206 or newer}
{$endif}

unit Turbo3;

interface

uses GPC, System, CRT;

(*@@*) type AnyFile=File;

var
  Kbd : Text;
  CBreak : Boolean absolute CheckBreak;

procedure AssignKbd (var F : (*AnyFile*)Text);
function  (*@@fjf260*)MemAvail3 : Integer;
function  (*@@fjf260*)MaxAvail3 : Integer;
function  LongFileSize (var F : AnyFile) : Real;
function  LongFilePos  (var F : AnyFile) : Real;
procedure LongSeek     (var F : AnyFile; Pos : Real);
procedure (*@@fjf260*)LowVideo3;
procedure (*@@fjf260*)HighVideo3;
procedure (*@@fjf260*)NormVideo3;

implementation

{$B-,I-}

function Kbd_Read (var PrivateData; var Buffer; Size : SizeType) = Result : SizeType;
var CharBuf : array [1 .. Size] of Char absolute Buffer;
begin
  Result := 0;
  repeat
    Inc (Result);
    CharBuf [Result] := ReadKey;
    if CharBuf [Result] = #0 then CharBuf [Result] := #27
  until (Result = Size) or not KeyPressed
end;

procedure AssignKbd (var F : (*AnyFile*)Text);
begin
  AssignTFDD (F, (*@@fjf258*)TOpenFunc(nil), TSelectProc(nil), Kbd_Read, (*@@*)TWriteFunc(nil),TFlushProc(nil),TCloseProc(nil),TDoneProc(nil), nil)
end;

function MemAvail3 : Integer;
begin
  MemAvail3 := MemAvail div 16
end;

function MaxAvail3 : Integer;
begin
  MaxAvail3 := MaxAvail div 16
end;

function LongFileSize (var F : AnyFile) : Real;
begin
  LongFileSize := FileSize (F)
end;

function LongFilePos (var F : AnyFile) : Real;
begin
  LongFilePos := FilePos (F)
end;

procedure LongSeek (var F : AnyFile; Pos : Real);
begin
  Seek (F, Round (Pos))
end;

procedure LowVideo3;
begin
  TextColor (LightGray);
  TextBackground (Black)
end;

procedure HighVideo3;
begin
  TextColor (Yellow);
  TextBackground (Black)
end;

procedure NormVideo3;
begin
  HighVideo3
end;

to begin do
begin
  NormVideo3;
  AssignKbd (Kbd);
  Reset (Kbd)
end;

end.
